#!/bin/sh

#exit

. /etc/motlawa/motlawa.conf

err=`echo "show slave status\G"|mysql 2>/dev/null |grep Last_Errno|awk '{print $2}'`
ioerr=`echo "show slave status\G"|mysql 2>/dev/null |grep Last_IO_Errno|awk '{print $2}'`
sbm=`echo "show slave status\G"|mysql 2>/dev/null|grep Seconds_Behind|awk '{print $2}'`

log=/etc/motlawa/repl/replication_watchdog.log
lock=/etc/motlawa/repl/replication_watchdog.err
verbose=""

mailto=$alert_mail
[ -z "$mailto"   ] && mailto="apro68@gmail.com"
[ -z "$maxdelay" ] && maxdelay=1000
[ -z "$server"   ] && server=$firma
[ -z "$sbm" ] && sbm=-2
[ "$sbm" == "NULL" ] && sbm=-1
[ $verbose ] && echo SBM: $sbm

subject="$server replication:"
echo `date` Error: $err IOError: $ioerr Secs: $sbm >> $log 
#exit

if [ $sbm -gt $maxdelay ]; then
[ $verbose ] && echo "Delay: $sbm"
subject="$subject Delay: $sbm"
err=-1
fi

if [ $sbm -eq -1 ]; then
[ $verbose ] && echo "Secs is NULL"
subject="$subject Secs is NULL"
err=-2
fi

if [ $sbm -eq -2 ]; then
[ $verbose ] && echo "MySQL stopped"
subject="$subject MySQL stopped"
err=-3
fi

if [ $err -eq 0 -a $ioerr -eq 0 ]; then
subject="$subject Resumed OK, Delay: $sbm"
[ -e $lock ] && echo "Resumed"|mail -s "$subject" $mailto && rm -f $lock

#echo "jest cacy"
else
subject="$subject Error: $err IOError: $ioerr"
if [ ! -e $lock ]; then
  [ $err -eq -1 ] && echo "Delay"|mail -s "$subject" $mailto 
  [ $err -eq -2 ] && echo "show slave status\G"|mysql|grep Error|mail -s "$subject" $mailto 
  [ $err -eq -3 ] && echo "MySQL stopped"|mail -s "$subject" $mailto 
  [ $ioerr -ne 0 ] && echo "IO Error"|mail -s "$subject" $mailto 
else
  [ $verbose ] && echo "Lock"
fi
touch $lock
#echo "jest blad nr: $err"
fi
